// ***********************************************
// This example commands.js shows you how to
// create various custom commands and overwrite
// existing commands.
//
// For more comprehensive examples of custom
// commands please read more here:
// https://on.cypress.io/custom-commands
// ***********************************************
//
//
// -- This is a parent command --
// Cypress.Commands.add('login', (email, password) => { ... })
//
//
// -- This is a child command --
// Cypress.Commands.add('drag', { prevSubject: 'element'}, (subject, options) => { ... })
//
//
// -- This is a dual command --
// Cypress.Commands.add('dismiss', { prevSubject: 'optional'}, (subject, options) => { ... })
//
//
// -- This will overwrite an existing command --
// Cypress.Commands.overwrite('visit', (originalFn, url, options) => { ... })

declare global {
   namespace Cypress {
      interface Chainable {
         getIframeBody(selector: string): Chainable<JQuery>;
         inIframe(selector: string, callback: (chainable: Chainable<JQuery>) => unknown): void;
      }
   }
}
Cypress.Commands.add('getIframeBody', (selector) => {
   return cy
      .get(selector, { timeout: 30000 })
      .should('be.visible')
      .its('0.contentDocument.body', { timeout: 30000 })
      .should('not.be.empty');
});

Cypress.Commands.add('inIframe', (selector, callback) => {
   return cy.getIframeBody(selector).then(($body) => {
      callback(cy.wrap($body));
   });
});

export {};
